(function(){var P$=Clazz.newPackage("java.util.concurrent"),I$=[['java.util.concurrent.atomic.AtomicInteger','java.util.concurrent.locks.ReentrantLock',['java.util.concurrent.LinkedBlockingQueue','.Node'],'java.lang.reflect.Array',['java.util.concurrent.LinkedBlockingQueue','.Itr']]],$incl$=function(i){return I$[i]=Clazz.load(I$[0][i-1])};
var C$=Clazz.newClass(P$, "LinkedBlockingQueue", function(){
Clazz.newInstance(this, arguments,0,C$);
}, 'java.util.AbstractQueue', ['java.util.concurrent.BlockingQueue', 'java.io.Serializable']);
var p$=C$.prototype;

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.capacity = 0;
this.count = null;
this.head = null;
this.last = null;
this.takeLock = null;
this.notEmpty = null;
this.putLock = null;
this.notFull = null;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
this.count = Clazz.new_((I$[1]||$incl$(1)).c$$I,[0]);
this.takeLock = Clazz.new_((I$[2]||$incl$(2)));
this.notEmpty = this.takeLock.newCondition();
this.putLock = Clazz.new_((I$[2]||$incl$(2)));
this.notFull = this.putLock.newCondition();
}, 1);

Clazz.newMeth(C$, 'signalNotEmpty', function () {
var takeLock = this.takeLock;
takeLock.lock();
try {
this.notEmpty.signal();
} finally {
takeLock.unlock();
}
});

Clazz.newMeth(C$, 'signalNotFull', function () {
var putLock = this.putLock;
putLock.lock();
try {
this.notFull.signal();
} finally {
putLock.unlock();
}
});

Clazz.newMeth(C$, ['insert$TE'], function (x) {
this.last=this.last.next=Clazz.new_((I$[3]||$incl$(3)).c$$TE,[x]);
});

Clazz.newMeth(C$, 'extract', function () {
var first = this.head.next;
this.head=first;
var x = first.item;
first.item=null;
return x;
});

Clazz.newMeth(C$, 'fullyLock', function () {
this.putLock.lock();
this.takeLock.lock();
});

Clazz.newMeth(C$, 'fullyUnlock', function () {
this.takeLock.unlock();
this.putLock.unlock();
});

Clazz.newMeth(C$, 'c$', function () {
C$.c$$I.apply(this, [2147483647]);
}, 1);

Clazz.newMeth(C$, 'c$$I', function (capacity) {
Clazz.super_(C$, this,1);
if (capacity <= 0) throw Clazz.new_(Clazz.load('java.lang.IllegalArgumentException'));
this.capacity=capacity;
this.last=this.head=Clazz.new_((I$[3]||$incl$(3)).c$$TE,[null]);
}, 1);

Clazz.newMeth(C$, 'c$$java_util_Collection', function (c) {
C$.c$$I.apply(this, [2147483647]);
for (var e, $e = c.iterator(); $e.hasNext()&&((e=$e.next()),1);) this.add$TE(e);

}, 1);

Clazz.newMeth(C$, 'size', function () {
return this.count.get();
});

Clazz.newMeth(C$, 'remainingCapacity', function () {
return this.capacity - this.count.get();
});

Clazz.newMeth(C$, ['put$TE'], function (e) {
if (e == null ) throw Clazz.new_(Clazz.load('java.lang.NullPointerException'));
var c = -1;
var putLock = this.putLock;
var count = this.count;
putLock.lockInterruptibly();
try {
try {
while (count.get() == this.capacity)this.notFull.await();

} catch (ie) {
if (Clazz.exceptionOf(ie, "java.lang.InterruptedException")){
this.notFull.signal();
throw ie;
} else {
throw ie;
}
}
p$.insert$TE.apply(this, [e]);
c=count.getAndIncrement();
if (c + 1 < this.capacity) this.notFull.signal();
} finally {
putLock.unlock();
}
if (c == 0) p$.signalNotEmpty.apply(this, []);
});

Clazz.newMeth(C$, ['offer$TE$J$java_util_concurrent_TimeUnit'], function (e, timeout, unit) {
if (e == null ) throw Clazz.new_(Clazz.load('java.lang.NullPointerException'));
var nanos = unit.toNanos$J(timeout);
var c = -1;
var putLock = this.putLock;
var count = this.count;
putLock.lockInterruptibly();
try {
for (; ; ) {
if (count.get() < this.capacity) {
p$.insert$TE.apply(this, [e]);
c=count.getAndIncrement();
if (c + 1 < this.capacity) this.notFull.signal();
break;
}if (nanos <= 0) return false;
try {
nanos=this.notFull.awaitNanos$J(nanos);
} catch (ie) {
if (Clazz.exceptionOf(ie, "java.lang.InterruptedException")){
this.notFull.signal();
throw ie;
} else {
throw ie;
}
}
}
} finally {
putLock.unlock();
}
if (c == 0) p$.signalNotEmpty.apply(this, []);
return true;
});

Clazz.newMeth(C$, ['offer$TE'], function (e) {
if (e == null ) throw Clazz.new_(Clazz.load('java.lang.NullPointerException'));
var count = this.count;
if (count.get() == this.capacity) return false;
var c = -1;
var putLock = this.putLock;
putLock.lock();
try {
if (count.get() < this.capacity) {
p$.insert$TE.apply(this, [e]);
c=count.getAndIncrement();
if (c + 1 < this.capacity) this.notFull.signal();
}} finally {
putLock.unlock();
}
if (c == 0) p$.signalNotEmpty.apply(this, []);
return c >= 0;
});

Clazz.newMeth(C$, 'take', function () {
var x;
var c = -1;
var count = this.count;
var takeLock = this.takeLock;
takeLock.lockInterruptibly();
try {
try {
while (count.get() == 0)this.notEmpty.await();

} catch (ie) {
if (Clazz.exceptionOf(ie, "java.lang.InterruptedException")){
this.notEmpty.signal();
throw ie;
} else {
throw ie;
}
}
x=p$.extract.apply(this, []);
c=count.getAndDecrement();
if (c > 1) this.notEmpty.signal();
} finally {
takeLock.unlock();
}
if (c == this.capacity) p$.signalNotFull.apply(this, []);
return x;
});

Clazz.newMeth(C$, 'poll$J$java_util_concurrent_TimeUnit', function (timeout, unit) {
var x = null;
var c = -1;
var nanos = unit.toNanos$J(timeout);
var count = this.count;
var takeLock = this.takeLock;
takeLock.lockInterruptibly();
try {
for (; ; ) {
if (count.get() > 0) {
x=p$.extract.apply(this, []);
c=count.getAndDecrement();
if (c > 1) this.notEmpty.signal();
break;
}if (nanos <= 0) return null;
try {
nanos=this.notEmpty.awaitNanos$J(nanos);
} catch (ie) {
if (Clazz.exceptionOf(ie, "java.lang.InterruptedException")){
this.notEmpty.signal();
throw ie;
} else {
throw ie;
}
}
}
} finally {
takeLock.unlock();
}
if (c == this.capacity) p$.signalNotFull.apply(this, []);
return x;
});

Clazz.newMeth(C$, 'poll', function () {
var count = this.count;
if (count.get() == 0) return null;
var x = null;
var c = -1;
var takeLock = this.takeLock;
takeLock.lock();
try {
if (count.get() > 0) {
x=p$.extract.apply(this, []);
c=count.getAndDecrement();
if (c > 1) this.notEmpty.signal();
}} finally {
takeLock.unlock();
}
if (c == this.capacity) p$.signalNotFull.apply(this, []);
return x;
});

Clazz.newMeth(C$, 'peek', function () {
if (this.count.get() == 0) return null;
var takeLock = this.takeLock;
takeLock.lock();
try {
var first = this.head.next;
if (first == null ) return null;
 else return first.item;
} finally {
takeLock.unlock();
}
});

Clazz.newMeth(C$, 'remove$O', function (o) {
if (o == null ) return false;
var removed = false;
p$.fullyLock.apply(this, []);
try {
var trail = this.head;
var p = this.head.next;
while (p != null ){
if (o.equals$O(p.item)) {
removed=true;
break;
}trail=p;
p=p.next;
}
if (removed) {
p.item=null;
trail.next=p.next;
if (this.last === p ) this.last=trail;
if (this.count.getAndDecrement() == this.capacity) this.notFull.signalAll();
}} finally {
p$.fullyUnlock.apply(this, []);
}
return removed;
});

Clazz.newMeth(C$, 'toArray', function () {
p$.fullyLock.apply(this, []);
try {
var size = this.count.get();
var a = Clazz.array(java.lang.Object, [size]);
var k = 0;
for (var p = this.head.next; p != null ; p=p.next) a[k++]=p.item;

return a;
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'toArray$TTA', function (a) {
p$.fullyLock.apply(this, []);
try {
var size = this.count.get();
if (a.length < size) a=Clazz.array(a.getClass().getComponentType(), size);
var k = 0;
for (var p = this.head.next; p != null ; p=p.next) a[k++]=p.item;

if (a.length > k) a[k]=null;
return a;
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'toString', function () {
p$.fullyLock.apply(this, []);
try {
return C$.superclazz.prototype.toString.apply(this, []);
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'clear', function () {
p$.fullyLock.apply(this, []);
try {
this.head.next=null;
Clazz.assert(C$, this, function(){return this.head.item == null });
this.last=this.head;
if (this.count.getAndSet$I(0) == this.capacity) this.notFull.signalAll();
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'drainTo$java_util_Collection', function (c) {
if (c == null ) throw Clazz.new_(Clazz.load('java.lang.NullPointerException'));
if (c === this ) throw Clazz.new_(Clazz.load('java.lang.IllegalArgumentException'));
var first;
p$.fullyLock.apply(this, []);
try {
first=this.head.next;
this.head.next=null;
Clazz.assert(C$, this, function(){return this.head.item == null });
this.last=this.head;
if (this.count.getAndSet$I(0) == this.capacity) this.notFull.signalAll();
} finally {
p$.fullyUnlock.apply(this, []);
}
var n = 0;
for (var p = first; p != null ; p=p.next) {
c.add$TE(p.item);
p.item=null;
++n;
}
return n;
});

Clazz.newMeth(C$, 'drainTo$java_util_Collection$I', function (c, maxElements) {
if (c == null ) throw Clazz.new_(Clazz.load('java.lang.NullPointerException'));
if (c === this ) throw Clazz.new_(Clazz.load('java.lang.IllegalArgumentException'));
p$.fullyLock.apply(this, []);
try {
var n = 0;
var p = this.head.next;
while (p != null  && n < maxElements ){
c.add$TE(p.item);
p.item=null;
p=p.next;
++n;
}
if (n != 0) {
this.head.next=p;
Clazz.assert(C$, this, function(){return this.head.item == null });
if (p == null ) this.last=this.head;
if (this.count.getAndAdd$I(-n) == this.capacity) this.notFull.signalAll();
}return n;
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'iterator', function () {
return Clazz.new_((I$[5]||$incl$(5)), [this, null]);
});

Clazz.newMeth(C$, 'writeObject$java_io_ObjectOutputStream', function (s) {
p$.fullyLock.apply(this, []);
try {
s.defaultWriteObject();
for (var p = this.head.next; p != null ; p=p.next) s.writeObject$O(p.item);

s.writeObject$O(null);
} finally {
p$.fullyUnlock.apply(this, []);
}
});

Clazz.newMeth(C$, 'readObject$java_io_ObjectInputStream', function (s) {
s.defaultReadObject();
this.count.set$I(0);
this.last=this.head=Clazz.new_((I$[3]||$incl$(3)).c$$TE,[null]);
for (; ; ) {
var item = s.readObject();
if (item == null ) break;
this.add$TE(item);
}
});
C$.$_ASSERT_ENABLED_ = ClassLoader.$getClassAssertionStatus(C$);
;
(function(){var C$=Clazz.newClass(P$.LinkedBlockingQueue, "Node", function(){
Clazz.newInstance(this, arguments[0],false,C$);
});

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.item = null;
this.next = null;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$$TE', function (x) {
C$.$init$.apply(this);
this.item=x;
}, 1);

Clazz.newMeth(C$);
})()
;
(function(){var C$=Clazz.newClass(P$.LinkedBlockingQueue, "Itr", function(){
Clazz.newInstance(this, arguments[0],true,C$);
}, null, 'java.util.Iterator');

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.current = null;
this.lastRet = null;
this.currentElement = null;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$', function () {
C$.$init$.apply(this);
var putLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].putLock;
var takeLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].takeLock;
putLock.lock();
takeLock.lock();
try {
this.current=this.this$0.head.next;
if (this.current != null ) this.currentElement=this.current.item;
} finally {
takeLock.unlock();
putLock.unlock();
}
}, 1);

Clazz.newMeth(C$, 'hasNext', function () {
return this.current != null ;
});

Clazz.newMeth(C$, 'next', function () {
var putLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].putLock;
var takeLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].takeLock;
putLock.lock();
takeLock.lock();
try {
if (this.current == null ) throw Clazz.new_(Clazz.load('java.util.NoSuchElementException'));
var x = this.currentElement;
this.lastRet=this.current;
this.current=this.current.next;
if (this.current != null ) this.currentElement=this.current.item;
return x;
} finally {
takeLock.unlock();
putLock.unlock();
}
});

Clazz.newMeth(C$, 'remove', function () {
if (this.lastRet == null ) throw Clazz.new_(Clazz.load('java.lang.IllegalStateException'));
var putLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].putLock;
var takeLock = this.b$['java.util.concurrent.LinkedBlockingQueue'].takeLock;
putLock.lock();
takeLock.lock();
try {
var node = this.lastRet;
this.lastRet=null;
var trail = this.this$0.head;
var p = this.this$0.head.next;
while (p != null  && p !== node  ){
trail=p;
p=p.next;
}
if (p === node ) {
p.item=null;
trail.next=p.next;
if (this.this$0.last === p ) this.this$0.last=trail;
var c = this.this$0.count.getAndDecrement();
if (c == this.this$0.capacity) this.this$0.notFull.signalAll();
}} finally {
takeLock.unlock();
putLock.unlock();
}
});
})()
})();
//Created 2018-06-24 09:52:01
